#ifndef APU_H
#define APU_H

typedef __fastcall void(*fp_mapper_apu_clock)(int);
void apu_set_mapper_apu_clock(fp_mapper_apu_clock);

void apu_fill_fs_update_frequency_lookup(void);
void apu_fill_dmc_update_frequency_lookup(void);
void apu_fill_noise_frequency_lookup(void);

int apu_get_buffer_dmc_counter(void);
void apu_set_buffer_counters(int);
void apu_kill_cycle(void);
void apu_rewrite_fs(void);

void apu_end_frame(void);
void apu_new_frame(void);
void apu_init(void);
void apu_clean(void);


void __fastcall apu_write_square0_control(u8);
void __fastcall apu_write_square0_sweep(u8);
void __fastcall apu_write_square0_timer(u8);
void __fastcall apu_write_square0_length(u8);
void __fastcall apu_write_square1_control(u8);
void __fastcall apu_write_square1_sweep(u8);
void __fastcall apu_write_square1_timer(u8);
void __fastcall apu_write_square1_length(u8);

void __fastcall apu_write_triangle_linear(u8);
void __fastcall apu_write_triangle_timer(u8);
void __fastcall apu_write_triangle_length(u8);

void __fastcall apu_write_noise_envelope(u8);
void __fastcall apu_write_noise_timer(u8);
void __fastcall apu_write_noise_length(u8);

void __fastcall apu_write_dmc_control(u8);
void __fastcall apu_write_dmc_dac(u8);
void __fastcall apu_write_dmc_address(u8);
void __fastcall apu_write_dmc_length(u8);
void __fastcall apu_run_dmc(void); /* I just *had* to call it Run-DMC */

void __fastcall apu_square0_update(void);
void __fastcall apu_square1_update(void);
void __fastcall apu_triangle_update(void);
void __fastcall apu_noise_update(void);
void __fastcall apu_dmc_update(void);
void __fastcall apu_force_update(void);

void __fastcall apu_write_status(u8);
u8 __fastcall apu_read_status(u16);

void __fastcall apu_write_fs(u8);
void __fastcall apu_run_fs(void);

#endif /* APU_H */
