#ifndef CONT_H
#define CONT_H

/* ports */
enum {
	CONT_P1=0,
	CONT_P2,
	CONT_PEXT,
	
	CONT_P_MAX
};

/* devices */
enum {
	CONT_D_NJ=0,	/* NES joypad (any port) */
	CONT_D_FJ,		/* Famicom joypad (any port) */
	CONT_D_PP,		/* power pad */
	CONT_D_FT,		/* family trainer */
	CONT_D_HS,		/* hypershot */
	CONT_D_FS,		/* four score */
	CONT_D_4P,		/* 4 players adaptor */
	CONT_D_FK,		/* family basic keyboard */
	
	CONT_D_NOTHING,
	
	CONT_D_MAX
};
/* alternate names */
enum {
	CONT_DA_MIC=0,	/* famicom mic */
	CONT_DA_J1,		/* joypad 1 */
	CONT_DA_J2,		/* joypad 2 */
	CONT_DA_J3,		/* joypad 3 */
	CONT_DA_J4,		/* joypad 4 */
	CONT_DA_PPFT,	/* power pad/family trainer */
	CONT_DA_HS,		/* hypershot */
	CONT_DA_KEY,	/* keyboard */
	
	CONT_DA_MAX,
	
	CONT_DA_EMPTY
};


/* triggers */
/* famicom microphone */
#define CONT_T_MIC_BEGIN 0
enum {
	CONT_T_MIC=CONT_T_MIC_BEGIN,
	
	CONT_T_MIC_END
};
/* joypad 1 */
#define CONT_T_J1_BEGIN CONT_T_MIC_END
enum {
	CONT_T_J1_A=CONT_T_J1_BEGIN,
	CONT_T_J1_B,
	CONT_T_J1_SELECT,
	CONT_T_J1_START,
	CONT_T_J1_UP,
	CONT_T_J1_DOWN,
	CONT_T_J1_LEFT,
	CONT_T_J1_RIGHT,
	
	CONT_T_J1_END
};
/* joypad 2 */
#define CONT_T_J2_BEGIN CONT_T_J1_END
enum {
	CONT_T_J2_A=CONT_T_J2_BEGIN,
	CONT_T_J2_B,
	CONT_T_J2_SELECT,
	CONT_T_J2_START,
	CONT_T_J2_UP,
	CONT_T_J2_DOWN,
	CONT_T_J2_LEFT,
	CONT_T_J2_RIGHT,
	
	CONT_T_J2_END
};
/* joypad 3 */
#define CONT_T_J3_BEGIN CONT_T_J2_END
enum {
	CONT_T_J3_A=CONT_T_J3_BEGIN,
	CONT_T_J3_B,
	CONT_T_J3_SELECT,
	CONT_T_J3_START,
	CONT_T_J3_UP,
	CONT_T_J3_DOWN,
	CONT_T_J3_LEFT,
	CONT_T_J3_RIGHT,
	
	CONT_T_J3_END
};
/* joypad 4 */
#define CONT_T_J4_BEGIN CONT_T_J3_END
enum {
	CONT_T_J4_A=CONT_T_J4_BEGIN,
	CONT_T_J4_B,
	CONT_T_J4_SELECT,
	CONT_T_J4_START,
	CONT_T_J4_UP,
	CONT_T_J4_DOWN,
	CONT_T_J4_LEFT,
	CONT_T_J4_RIGHT,
	
	CONT_T_J4_END
};
/* power pad */
#define CONT_T_PP_BEGIN CONT_T_J4_END
enum {
	CONT_T_PP_1=CONT_T_PP_BEGIN,
	CONT_T_PP_2,
	CONT_T_PP_3,
	CONT_T_PP_4,
	CONT_T_PP_5,
	CONT_T_PP_6,
	CONT_T_PP_7,
	CONT_T_PP_8,
	CONT_T_PP_9,
	CONT_T_PP_10,
	CONT_T_PP_11,
	CONT_T_PP_12,
	
	CONT_T_PP_END
};
/* hypershot */
#define CONT_T_HS_BEGIN CONT_T_PP_END
enum {
	CONT_T_HS_IJUMP=CONT_T_HS_BEGIN,
	CONT_T_HS_IRUN,
	CONT_T_HS_IIJUMP,
	CONT_T_HS_IIRUN,
	
	CONT_T_HS_END
};
/* keyboard */
#define CONT_T_K_BEGIN CONT_T_HS_END
enum {
	CONT_T_K_0=CONT_T_K_BEGIN,
	CONT_T_K_1,
	CONT_T_K_2,
	CONT_T_K_3,
	CONT_T_K_4,
	CONT_T_K_5,
	CONT_T_K_6,
	CONT_T_K_7,
	CONT_T_K_8,
	CONT_T_K_9,
	CONT_T_K_A,
	CONT_T_K_B,
	CONT_T_K_C,
	CONT_T_K_D,
	CONT_T_K_E,
	CONT_T_K_F,
	CONT_T_K_G,
	CONT_T_K_H,
	CONT_T_K_I,
	CONT_T_K_J,
	CONT_T_K_K,
	CONT_T_K_L,
	CONT_T_K_M,
	CONT_T_K_N,
	CONT_T_K_O,
	CONT_T_K_P,
	CONT_T_K_Q,
	CONT_T_K_R,
	CONT_T_K_S,
	CONT_T_K_T,
	CONT_T_K_U,
	CONT_T_K_V,
	CONT_T_K_W,
	CONT_T_K_X,
	CONT_T_K_Y,
	CONT_T_K_Z,
	CONT_T_K_F1,
	CONT_T_K_F2,
	CONT_T_K_F3,
	CONT_T_K_F4,
	CONT_T_K_F5,
	CONT_T_K_F6,
	CONT_T_K_F7,
	CONT_T_K_F8,
	CONT_T_K_MINUS,
	CONT_T_K_CIRCUMFLEX,
	CONT_T_K_YEN,
	CONT_T_K_AT,
	CONT_T_K_LEFTBRACKET,
	CONT_T_K_RIGHTBRACKET,
	CONT_T_K_SEMICOLON,
	CONT_T_K_COLON,
	CONT_T_K_COMMA,
	CONT_T_K_PERIOD,
	CONT_T_K_SLASH,
	CONT_T_K_UNDERSCORE,
	CONT_T_K_SPACE,
	CONT_T_K_ESC,
	CONT_T_K_ENTER,
	CONT_T_K_CLRHOME,
	CONT_T_K_INS,
	CONT_T_K_DEL,
	CONT_T_K_UP,
	CONT_T_K_DOWN,
	CONT_T_K_LEFT,
	CONT_T_K_RIGHT,
	CONT_T_K_STOP,
	CONT_T_K_LEFTSHIFT,
	CONT_T_K_RIGHTSHIFT,
	CONT_T_K_CTRL,
	CONT_T_K_GRPH,
	CONT_T_K_KANA,
	
	CONT_T_K_END
};
#define CONT_T_MAX CONT_T_K_END


void cont_init(void);
void cont_settings_save(void);
void cont_clean(void);
void cont_reset(void);
void __fastcall cont_update(void);
void cont_init_cont(void);
void cont_clean_cont(void);
u32 cont_get_port(u32);
u32 cont_get_da(u32);

const char* cont_get_name(u32);
const char* cont_get_a_name(u32);
const char* cont_get_trigger_info(u32);

u8 __fastcall cont_read_port(u16);
void __fastcall cont_write_port(u8);


#endif /* CONT_H */
