/*

Family Basic keyboard (HVC-007):
	Family Basic, Playbox Basic

F1  F2  F3  F4  F5  F6  F7  F8
 1 2 3 4 5 6 7 8 9 0 - ^  STOP       CH* INS DEL
ESC Q W E R T Y U I O P @ [ ENTER         UP
CTR A S D F G H J K L ; : ] KANA      LEFT RIGHT
SHIFT Z X C V B N M , . / _ SHIFT        DOWN
       GRPH   SPACE

CH*=CLR HOME

a data recorder can be connected to the keyboard (HVC-008, unimplemented)

*/


static struct {
	int col;
	int row;
	int btn[9][2];
	
} _cont_keyboard;

#define cont_keyboard _cont_keyboard


_CONTREAD(familybasic)
{
	if (address) return cont_keyboard.btn[cont_keyboard.row][cont_keyboard.col];
	
	/* else read from data recorder */
	else return 0;
}

_CONTWRITE(familybasic)
{
	if (data&4) {
		input_need_update();
		
		/* increment row if bit 1 (column) goes from 1 to 0, bit 0 set: select first row */
		cont_keyboard.row=(data&1)?0:(cont_keyboard.row+(cont_keyboard.col&((data&2)==0)))%9;
		cont_keyboard.col=data>>1&1;
	}
	
	/* else write to data recorder */
}

_CONTUPDATE(familybasic)
{
	/* the matrix reloaded */
	#define k(row,col,k1,k2,k3,k4) cont_keyboard.btn[row][col]=((input_trigger_held(CONT_T_K_##k1)<<1)|(input_trigger_held(CONT_T_K_##k2)<<2)|(input_trigger_held(CONT_T_K_##k3)<<3)|(input_trigger_held(CONT_T_K_##k4)<<4))^BIN8(00011110)
	k(0,0,F8,			ENTER,		LEFTBRACKET,RIGHTBRACKET);
	k(0,1,KANA,			RIGHTSHIFT,	YEN,		STOP		);
	k(1,0,F7,			AT,			COLON,		SEMICOLON	);
	k(1,1,UNDERSCORE,	SLASH,		MINUS,		CIRCUMFLEX	);
	k(2,0,F6,			O,			L,			K			);
	k(2,1,PERIOD,		COMMA,		P,			0			);
	k(3,0,F5,			I,			U,			J			);
	k(3,1,M,			N,			9,			8			);
	k(4,0,F4,			Y,			G,			H			);
	k(4,1,B,			V,			7,			6			);
	k(5,0,F3,			T,			R,			D			);
	k(5,1,F,			C,			5,			4			);
	k(6,0,F2,			W,			S,			A			);
	k(6,1,X,			Z,			E,			3			);
	k(7,0,F1,			ESC,		Q,			CTRL		);
	k(7,1,LEFTSHIFT,	GRPH,		1,			2			);
	k(8,0,CLRHOME,		UP,			RIGHT,		LEFT		);
	k(8,1,DOWN,			SPACE,		DEL,		INS			);
	#undef k
}

_CONTINIT(familybasic)
{
	SET_CONTREAD(familybasic);
	SET_CONTWRITE(familybasic);
	SET_CONTUPDATE(familybasic);
}
