/*

US: Power Pad:
	Athletic World, NES PowerPad Test Cart, Dance Aerobics, Short Order/Eggsplode,
	Stadium Events, Street Cop, Super Mario Bros. + Duck Hunt + World Class Track Meet,
	Super Team Games, World Class Track Meet
EU: Family Fun Fitness:
	Athletic World, Stadium Events
JP: Family Trainer (by Bandai, using extended port):
	Aerobics Studio, Athletic World, Daiundoukai, Fuuun! Takeshi Shiro 2,
	Jogging Race, Manhattan Police, Meiro Daisakusen, Rairai Kyonshiizu,
	Running Stadium, Totsugeki! Fuuun Takeshi Shiro

side A (blue (EU/JP:green),red):
    B  B
 B  R  R  B
    B  B
side B (flipped):
 1  2  3  4
 5  6  7  8
 9 10 11 12

*/


static struct {
	int strobe;
	int shift;
	int reg;
	u8 btn[8];
	u8 btn_upd[8];
	
} _cont_powerpad[CONT_P_MAX];

#define cont_powerpad _cont_powerpad[port]


/* powerpad */

_CONTREAD(powerpad)
{
	if (cont_powerpad.strobe) { 
		input_need_update();
		memcpy(cont_powerpad.btn,cont_powerpad.btn_upd,8);
		return cont_powerpad.btn[0];
	}
	else if (cont_powerpad.shift<8) return cont_powerpad.btn[cont_powerpad.shift++];
	else return 0x18;
}

_CONTWRITE(powerpad)
{
	if (data) cont_powerpad.shift=0;
	else if (cont_powerpad.strobe) { /* 1 -> 0 */
		input_need_update();
		memcpy(cont_powerpad.btn,cont_powerpad.btn_upd,8);
	}
	cont_powerpad.strobe=data;
}

_CONTUPDATE(powerpad)
{
	/* serial button status, bit 3: 2,1,5,9,6,10,11,7. bit 4: 4,3,12,8,x,x,x,x */
	const int b[]={1,0,4,8,5,9,10,6,3,2,11,7};
	int i=CONT_T_PP_BEGIN,j=8;
	
	while (j--) {
		cont_powerpad.btn_upd[j]=input_trigger_held(i+b[j])<<3;
		if (j<4) cont_powerpad.btn_upd[j]|=(input_trigger_held(i+b[j|8])<<4);
		else cont_powerpad.btn_upd[j]|=0x10;
	}
}

_CONTRESET(powerpad)
{
	_contwrite[port](1,port);
	_contwrite[port](0,port);
}

_CONTINIT(powerpad)
{
	SET_CONTREAD(powerpad);
	SET_CONTWRITE(powerpad);
	SET_CONTUPDATE(powerpad);
	SET_CONTRESET(powerpad);
	cont_reset();
}


/* familytrainer */

_CONTREAD(familytrainer)
{
	if (address) return cont_powerpad.reg;
	else return 0;
}

_CONTWRITE(familytrainer)
{
	data=~data;
	if (data&4) { input_need_update(); cont_powerpad.reg=cont_powerpad.btn[0]; }		/* ~bit 2: 1,2,3,4 */
	else if (data&2) { input_need_update(); cont_powerpad.reg=cont_powerpad.btn[1]; }	/* ~bit 1: 5,6,7,8 */
	else if (data&1) { input_need_update(); cont_powerpad.reg=cont_powerpad.btn[2]; }	/* ~bit 0: 9,10,11,12 */
	else cont_powerpad.reg=0;
}

_CONTUPDATE(familytrainer)
{
	int i,j=0;
	for (i=CONT_T_PP_BEGIN;i<CONT_T_PP_END;i++,j++)
		cont_powerpad.btn[j>>2]=(cont_powerpad.btn[j>>2]|(input_trigger_held(i)^1))<<1&0x1e;
}

_CONTINIT(familytrainer)
{
	SET_CONTREAD(familytrainer);
	SET_CONTWRITE(familytrainer);
	SET_CONTUPDATE(familytrainer);
}
