#ifndef CPU_MEMORYMAP_H
#define CPU_MEMORYMAP_H

/* standard IO */
typedef __fastcall u8(*fp_cpu_read_io2000)(u16);
typedef __fastcall void(*fp_cpu_write_io2000)(u8);
typedef __fastcall u8(*fp_cpu_read_io4000)(u16);
typedef __fastcall void(*fp_cpu_write_io4000)(u8);
u8 __fastcall cpu_read_io_nothing(u16);
void __fastcall cpu_write_io_nothing(u8);
void cpu_set_io2000_std(void);
void cpu_set_io4000_std(void);
void cpu_set_read_io2000(u16,fp_cpu_read_io2000);
void cpu_set_write_io2000(u16,fp_cpu_write_io2000);
fp_cpu_write_io2000 __fastcall cpu_get_write_io2000(u16);
void cpu_set_read_io4000(u16,fp_cpu_read_io4000);
void cpu_set_write_io4000(u16,fp_cpu_write_io4000);

/* mapper IO functionpointers */
typedef __fastcall u8(*fp_cpu_read_io4020)(u16);
typedef __fastcall void(*fp_cpu_write_io4020)(u16,u8,u8);
typedef __fastcall u8(*fp_cpu_read_io6000)(u16);
typedef __fastcall void(*fp_cpu_write_io6000)(u16,u8,u8);
typedef __fastcall u8(*fp_cpu_read_io8000)(u16);
typedef __fastcall void(*fp_cpu_write_io8000)(u16,u8,u8);
void cpu_set_read_io4020(fp_cpu_read_io4020);
void cpu_set_write_io4020(fp_cpu_write_io4020);
void cpu_set_read_io6000(fp_cpu_read_io6000);
void cpu_set_write_io6000(fp_cpu_write_io6000);
void cpu_set_write_io8000(fp_cpu_write_io8000,fp_cpu_write_io8000,fp_cpu_write_io8000,fp_cpu_write_io8000);
void cpu_set_read_io8000(fp_cpu_read_io8000,fp_cpu_read_io8000,fp_cpu_read_io8000,fp_cpu_read_io8000);

/* memorymap read/write handlers */
u8 __fastcall cpu_read_ram(u16);
u8 __fastcall cpu_read_ppu(u16);
u8 __fastcall cpu_read_io(u16);
u8 __fastcall cpu_read_wram(u16);
u8 __fastcall cpu_read_prgbank1a(u16);
u8 __fastcall cpu_read_prgbank1b(u16);
u8 __fastcall cpu_read_prgbank2a(u16);
u8 __fastcall cpu_read_prgbank2b(u16);

void __fastcall cpu_write_ram(u16,u8);
void __fastcall cpu_write_ppu(u16,u8);
void __fastcall cpu_write_io(u16,u8);
void __fastcall cpu_write_wram(u16,u8);
void __fastcall cpu_write_prgbank1a(u16,u8);
void __fastcall cpu_write_prgbank1b(u16,u8);
void __fastcall cpu_write_prgbank2a(u16,u8);
void __fastcall cpu_write_prgbank2b(u16,u8);

u8 __fastcall cpu_read_wram_override(u16);
void __fastcall cpu_write_wram_override(u16,u8);

u8 __fastcall cpu_read_prgbank1a_override(u16);
u8 __fastcall cpu_read_prgbank1b_override(u16);
u8 __fastcall cpu_read_prgbank2a_override(u16);
u8 __fastcall cpu_read_prgbank2b_override(u16);


void cpu_memmap_init(void);
void cpu_memmap_clean(void);
void cpu_memmap_fill_ram(u8);

#endif /* CPU_MEMORYMAP_H */
