#ifndef CRYSTAL_H
#define CRYSTAL_H

typedef struct {
	
	int lines;
	
	int overclock;
	int cycle;
	int rel_cycle;
	int frame;
	int max_cycles;
	int full_scanline;
	int hblank;
	int vblank_trigger;
	int ppu_scanline;
	int ppu_cycle;
	
	int mode; /* PAL/NTSC */
	int hc[313]; /* hblank counter: start of each hblank */
	int sc[313]; /* scanline counter: start of each scanline */
	
	int odd_frame;
	u32 fc;
	u32 fc_h;
	
	/* sound */
	int slice[2];
	int base;
	int sub;
	int cspf;
	
} Crystal;

Crystal* crystal;

void crystal_set_mode(int);
void crystal_set_cpuspeed(int);
void crystal_new_frame(void);
void crystal_init(void);
void crystal_settings_load(void);
void crystal_clean(void);

#endif /* CRYSTAL_H */
