#ifndef DRAW_H
#define DRAW_H

enum {
	DRAW_RENDERTYPE_D3D=0,
	DRAW_RENDERTYPE_DD,
	
	DRAW_RENDERTYPE_MAX
};

enum {
	DRAW_VIDFORMAT_NTSC=0,
	DRAW_VIDFORMAT_PAL,
	
	DRAW_VIDFORMAT_AUTO,
	
	DRAW_VIDFORMAT_MAX
};

enum {
	DRAW_VIDSIGNAL_MONOCHROME=0,
	DRAW_VIDSIGNAL_COMPOSITE,
	DRAW_VIDSIGNAL_SVIDEO,
	DRAW_VIDSIGNAL_RGB,
	
	DRAW_VIDSIGNAL_CUSTOM,
	
	DRAW_VIDSIGNAL_MAX
};

enum {
	DRAW_DECODER_INDUSTRIAL=0,
	DRAW_DECODER_SONY_CXA2025AS_U,
	DRAW_DECODER_SONY_CXA2025AS_J,
	DRAW_DECODER_SONY_CXA2095S_U,
	DRAW_DECODER_SONY_CXA2095S_J,
	
	DRAW_DECODER_CUSTOM,
	
	DRAW_DECODER_MAX
};

enum {
	DRAW_PALETTE_ASPIRINGSQUIRE=0,
	DRAW_PALETTE_BMF54123,
	DRAW_PALETTE_CHRIS_COVELL,
	DRAW_PALETTE_FX3,
	DRAW_PALETTE_LOOPY,
	DRAW_PALETTE_MATTHEW_CONTE,
	DRAW_PALETTE_SARDU,
	
	DRAW_PALETTE_HARDCODED_MAX
};
enum {
	DRAW_PALETTE_INTERNAL=DRAW_PALETTE_HARDCODED_MAX,
	
	DRAW_PALETTE_AUTO,
	
	DRAW_PALETTE_FILE,
	
	DRAW_PALETTE_MAX
};

enum {
	DRAW_BG_REDX=0,
	DRAW_BG_SMITH,
	DRAW_BG_SL,
	
	DRAW_BG_NOTHING,
	
	DRAW_BG_MAX
};

const char* draw_get_rendertype_name(u32);
const char* draw_get_vidformat_name(u32);
const char* draw_get_vidsignal_name(u32);
const char* draw_get_decoder_name(u32);
const char* draw_get_palette_name(u32);
const char* draw_get_bg_name(u32);


#define DRAW_SC_VIDSIGNAL	(1<<16)

void draw_set_surface_change(u32);


int draw_init(void);
void draw_init_ntsc(void);
void draw_init_settings(void);
void draw_init_palette(int);
void draw_save_palette(int);
int draw_load_palette(const char*,const char*);
void draw_set_window_size(void);
void draw_set_zoom(int);
BOOL CALLBACK draw_change_vidsignal_custom(HWND,UINT,WPARAM,LPARAM);
void draw_switch_screenmode(void);
void draw_show_menu(int);
void draw_setzero(void);
void draw_settings_save(void);
void draw_clean(void);
void draw_clean_ddraw(void);
void draw_draw(void);
void draw_repaint(void);
void __fastcall draw_check_reset(void);

int draw_get_cpu_illegal_count_set(void);
void draw_set_flip_x(int);
int draw_get_flip_x(void);
int draw_is_flip_x(void);
void draw_set_bfilter(int);
int draw_get_bfilter(void);
void draw_set_stretch(int);
int draw_get_stretch(void);
void draw_set_correct_aspect(int);
int draw_get_correct_aspect(void);
void draw_create_text_mutex(void);
void draw_set_text_max_ticks_default(void);
void draw_reset_burst_phase(void);
void draw_set_recreate(void);
void draw_set_repaint(int);
int draw_get_vsync(void);
void draw_set_vsync(int);
int draw_get_softrender(void);
void draw_set_softrender(int);
int draw_get_rendertype(void);
void draw_set_rendertype(int);
int draw_get_vidformat(void);
void draw_set_vidformat(int);
int draw_get_fullscreen(void);
int draw_get_fullscreen_set(void);
int draw_get_refreshrate(void);
u16* draw_get_screen_ptr(void);
void draw_text_add(int,int,const char*);
int draw_get_text(void);
void draw_set_text(int);
void draw_text_clean(void);
int draw_get_pixel(int,int);
int draw_get_5060(void);
int draw_get_5060_auto(void);
int draw_get_source_width(void);
int draw_get_source_height(void);

#endif /* DRAW_H */
