#ifndef FILE_H
#define FILE_H

typedef struct {
	char* name;
	char* dir;
	char* ext;
	char* filename;
	char* filename_inzip;
	char* appdir;
	char* appname;
	char* batterydir;
	char* patchdir;
	char* palettedir;
	char* romdir;
	char* sampledir;
	char* statedir;
	
	u32 crc32;
	u32 size;
	
	int is_zip;
} File;

File* file;

FILE* file_get_fd(void);
void file_setfile(char**,const char*,const char*,const char*);
int file_accessible(void);
int file_open(void);
int file_open_rw(void);
u8* file_from_resource(int,int*);
void file_from_resource_close(void);
int file_save(void);
int file_save_text(void);
int file_read(u8*,const int);
int file_write(const u8*,const int);
void file_close(void);
int file_patch_init(void);
void file_patch_close(void);

void file_init(void);
void file_directories(void);
BOOL CALLBACK file_directories_dialog(HWND,UINT,WPARAM,LPARAM);
void file_clean(void);
int file_setdirectory(char**);
void file_settings_save(void);

int file_get_zn(void);
void file_zn_reset(void);
void file_zn_next(void);
void file_zn_prev(void);

#endif /* FILE_H */
