#ifndef INPUT_H
#define INPUT_H

/* emulator shortcut triggers */
#define INPUT_T_BEGIN 0
enum {
	INPUT_T_RELOAD=INPUT_T_BEGIN,
	INPUT_T_SOFTRESET,
	INPUT_T_OPENGAME,
	INPUT_T_EXIT,
	INPUT_T_FULLSCREEN,
	INPUT_T_PAUSE,
	INPUT_T_VIDEOFORMAT,
	INPUT_T_CPUSPEEDMIN,
	INPUT_T_CPUSPEEDPLUS,
	INPUT_T_CARTSWITCHUP,
	INPUT_T_CARTSWITCHDOWN,
	INPUT_T_HELP,
	INPUT_T_CLOSE,
	INPUT_T_DISABLE,
	
	INPUT_T_END
};

void input_init(void);
void input_affirm_ports(void);
void input_clean(void);
void input_read(void);
void input_read_shortcuts(void);
void input_reset_updframe(void);
void input_need_update(void);
void input_vblank(void);
void input_settings_save(void);
const char* input_get_trigger_info(u32);
int input_set_trigger(const u32,const char*,u32);

int __fastcall input_trigger_held(int);

void input_doubleclick(void);
int input_mouse_in_client(HWND,HWND,POINT*);
void input_mouse_cursor_update(void);
void input_mouse_cursor_reset_ticks(void);
void input_cpuspeed_ticks_stall(void);
void input_cartswitch_ticks_stall(void);

int input_menukey(int);


#endif /* INPUT_H */
