#ifndef MAPPER_H
#define MAPPER_H

enum {
	MAPTYPE_ACTION_52,
	MAPTYPE_AGCI_50282,
	MAPTYPE_AVE_D_1012,
	MAPTYPE_AVE_NINA_001,
	MAPTYPE_AVE_NINA_003,
	MAPTYPE_BANDAI,
	MAPTYPE_BANDAI_PT_554,
	MAPTYPE_BANDAI_SIMPLE_M1,
	MAPTYPE_BANDAI_SIMPLE_M2,
	MAPTYPE_CALTRON_6_IN_1,
	MAPTYPE_HES_X_IN_1,
	MAPTYPE_CAMERICA_BF9093,
	MAPTYPE_CAMERICA_BF9096,
	MAPTYPE_CAMERICA_BF9096_ALADDIN,
	MAPTYPE_CAMERICA_BF9097,
	MAPTYPE_CAPCOM_SIMPLE,
	MAPTYPE_COLOR_DREAMS,
	MAPTYPE_FRONT_FAREAST_F3XXX,
	MAPTYPE_FRONT_FAREAST_F4XXX,
	MAPTYPE_FRONT_FAREAST_F8XXX,
	MAPTYPE_IREM_G_101,
	MAPTYPE_IREM_G_101_ALTERNATE_MIRRORING,
	MAPTYPE_IREM_H_3001,
	MAPTYPE_IREM_SIMPLE_C8,
	MAPTYPE_IREM_SIMPLE_M4,
	MAPTYPE_IREM_SIMPLE_P16U,
	MAPTYPE_JALECO_JF_KONAMI_SIMPLE,
	MAPTYPE_JALECO_JF_SIMPLE_GN,
	MAPTYPE_JALECO_JF_SIMPLE_M1,
	MAPTYPE_JALECO_JF_SIMPLE_P16S,
	MAPTYPE_JALECO_JF_SIMPLE_P16US,
	MAPTYPE_JALECO_JF_SIMPLE_P32S,
	MAPTYPE_JALECO_SS_88006,
	MAPTYPE_KONAMI_VRC1_JALECO_SS_88005,
	MAPTYPE_KONAMI_VRC2A,
	MAPTYPE_KONAMI_VRC2B_VRC4E,
	MAPTYPE_KONAMI_VRC3,
	MAPTYPE_KONAMI_VRC4A_VRC4C,
	MAPTYPE_KONAMI_VRC4B_VRC4D,
	MAPTYPE_KONAMI_VRC6A,
	MAPTYPE_KONAMI_VRC6B,
	MAPTYPE_KONAMI_VRC7A_VRC7B,
	MAPTYPE_NAMCOT_106,
	MAPTYPE_NAMCOT_106_STRIPPED_DOWN,
	MAPTYPE_NAMCOT_108,
	MAPTYPE_NAMCOT_118,
	MAPTYPE_NAMCOT_118_CHR_CONTROLLED_MIRRORING,
	MAPTYPE_NAMCOT_118_ONE_SCREEN_MIRRORING,
	MAPTYPE_NICHIBUTSU_SIMPLE,
	MAPTYPE_NINTENDO_AXROM,
	MAPTYPE_NINTENDO_BXROM,
	MAPTYPE_NINTENDO_CNROM,
	MAPTYPE_NINTENDO_CNROM_RELYING_ON_BUS_CONFLICTS,
	MAPTYPE_NINTENDO_CNROM_WITH_CHR_DISABLE0,
	MAPTYPE_NINTENDO_CNROM_WITH_CHR_DISABLE1,
	MAPTYPE_NINTENDO_CNROM_WITH_CHR_DISABLE2,
	MAPTYPE_NINTENDO_CNROM_WITH_CHR_DISABLE3,
	MAPTYPE_NINTENDO_CPROM,
	MAPTYPE_NINTENDO_GXROM,
	MAPTYPE_NINTENDO_MMC1_SxROM,
	MAPTYPE_NINTENDO_MMC1A_SxROM,
	MAPTYPE_NINTENDO_MMC1_SOROM,
	MAPTYPE_NINTENDO_MMC1_SXROM,
	MAPTYPE_NINTENDO_MMC1_WORLD_CHAMPIONSHIPS,
	MAPTYPE_NINTENDO_MMC2_PXROM,
	MAPTYPE_NINTENDO_MMC3_TXROM,
	MAPTYPE_NINTENDO_MMC3_TXSROM,
	MAPTYPE_NINTENDO_MMC3_TQROM,
	MAPTYPE_NINTENDO_MMC3_TR1ROM_TVROM,
	MAPTYPE_NINTENDO_MMC3_ALTERNATE_IRQ,
	MAPTYPE_NINTENDO_MMC3_WITHOUT_WRAM,
	MAPTYPE_NINTENDO_MMC3_SMB_TETRIS_WORLDCUP,
	MAPTYPE_NINTENDO_MMC3_VBALL_WORLDCUP,
	MAPTYPE_NINTENDO_MMC4_FXROM,
	MAPTYPE_NINTENDO_MMC5_EXROM,
	MAPTYPE_NINTENDO_MMC6_HXROM,
	MAPTYPE_NINTENDO_NROM,
	MAPTYPE_NINTENDO_NROM_FAMILY_BASIC,
	MAPTYPE_NINTENDO_NROM_WITH_COPYNES,
	MAPTYPE_NINTENDO_UXROM,
	MAPTYPE_PIRATE_MARIO_BABY,
	MAPTYPE_PIRATE_SMB2J_FDS,
	MAPTYPE_PIRATE_SMB2J_FDS_ALTERNATE,
	MAPTYPE_PIRATE_WAI_XING_ZHAN_SHI,
	MAPTYPE_PIRATE_MULTI_CONTRA_FUNCTION_16,
	MAPTYPE_PIRATE_MULTI_MMC3_MARIO_7_IN_1,
	MAPTYPE_PIRATE_MULTI_MMC3_SUPER_BIG_7_IN_1,
	MAPTYPE_RUMBLESTATION,
	MAPTYPE_SUNSOFT_1,
	MAPTYPE_SUNSOFT_2,
	MAPTYPE_SUNSOFT_2_HARDWIRED_MIRRORING,
	MAPTYPE_SUNSOFT_3,
	MAPTYPE_SUNSOFT_4,
	MAPTYPE_SUNSOFT_5,
	MAPTYPE_TENGEN_MIMIC_1,
	MAPTYPE_TENGEN_RAMBO_1,
	MAPTYPE_TENGEN_SIMPLE,
	MAPTYPE_TAITO_TC,
	MAPTYPE_TAITO_X_005,
	MAPTYPE_TAITO_X_005_ONE_SCREEN_MIRRORING,
	MAPTYPE_TAITO_X1_017,
	
	MAPTYPE_UNKNOWN,
	
	MAPTYPE_MAX
};

#define MAPSWITCH_UP		0
#define MAPSWITCH_DOWN		1
#define MAPSWITCH_SET(x)	2|(x<<8)

#define _MAPINIT(x) void mapper_init_m_##x(u32 maptype)
#define _MAPSWITCHINIT(x) void mapper_init_switches_##x(void)
#define _MAPSWITCHSAVE(x) void mapper_save_switches_##x(void)
#define _MAPIO(x) void __fastcall mapper_io_##x##_w(u16 address,u8 bus,u8 data)
#define _MAPIO_R(x) u8 __fastcall mapper_io_##x##_r(u16 address)
#define _MAPIRQ(x) void __fastcall mapper_irq_##x(void)
#define _MAPAPUCLOCK(x) void __fastcall mapper_apu_clock_##x(int c)
#define _MAPPPUBUS(x) void __fastcall mapper_ppubus_##x(u16 address)
#define _MAPA12(x) _MAPPPUBUS(x)
#define _MAPPPUMCS(x) void __fastcall mapper_ppumodechangesignal_##x(int enabled)
#define _MAPPPU_W(x,y) void __fastcall mapper_##x##_ppu_write_##y(u16 address,u8 data)
#define _MAPPPU_R(x,y) u8 __fastcall mapper_##x##_ppu_read_##y(u16 address)

#define MAPINIT_FUN(x) mapper_init_m_##x
#define MAPSWITCHINIT_FUN(x) mapper_init_switches_##x
#define MAPSWITCHSAVE_FUN(x) mapper_save_switches_##x
#define MAPIO_FUN(x) mapper_io_##x##_w
#define MAPIO_R_FUN(x) mapper_io_##x##_r
#define MAPPPUBUS_FUN(x) mapper_ppubus_##x

_MAPINIT(nothing);
_MAPIO(nothing);
_MAPIO_R(nothing);
_MAPAPUCLOCK(nothing);
_MAPPPUBUS(nothing);
_MAPPPUMCS(nothing);
_MAPPPUMCS(a12);
_MAPIRQ(nothing);
_MAPIRQ(updateppu);

void __fastcall mapper_ppu_write_memory_address_warmup_a12_override(u8);
void __fastcall mapper_ppu_write_memory_address_a12_override(u8);
u8 __fastcall mapper_ppu_read_memory_data_a12_override(u16);
void __fastcall mapper_ppu_write_memory_data_a12_override(u8);

typedef void(*fp_init_mapper)(u32);
void mapper_set_info(u32,const char*,const char*,int,int,int,fp_init_mapper);
void mapper_build_std_info(void);
void mapper_clean_info(void);
int mapperinfo_ines2maptype(u32);
int mapperinfo_maptype2ines(u32);
int mapperinfo_get_mapmir(u32);
int mapperinfo_supported(u32);
const char* mapperinfo_get_name(u32);
const char* mapperinfo_get_shortname(u32);
void mapper_init(void);
void mapper_init_switches(void);
void mapper_save_switches(void);
void mapper_init_mapper(u32);
void mapper_clean(void);
void mapper_clean_mapper(void);
void mapper_kill_cycle(void);
int mapper_battery_custom_load(void);
int mapper_battery_custom_save(void);
void mapper_new_frame(void);
void mapper_end_frame(void);
void mapper_reset(void);
void mapper_change_mode(void);
void mapper_set_sound_buffer_counters(int);
void mapper_sound_stream(signed short*,int);
void mapper_set_switches(u32);


/* ave */
/* nina 001 */
_MAPINIT(nina1);
_MAPIO(nina1);
/* nina 003 */
_MAPINIT(nina3);
_MAPIO(nina3);
/* d 1012 */
_MAPINIT(ave_d1012);
_MAPIO(ave_d1012);
_MAPIO_R(ave_d1012);



/* bandai */
/* bandai */
_MAPINIT(bandai);
_MAPIO(bandai);
_MAPIRQ(bandai);
/* simples */
_MAPINIT(bandai_l1);
_MAPIO(bandai_l1);



/* ffe */
/* all */
_MAPINIT(ffe);
_MAPIO(ffe);
_MAPIO(ffe_f4xxx_1);
_MAPIO(ffe_f4xxx_2);
_MAPIO(ffe_f8xxx);
_MAPIRQ(ffe);



/* irem */
/* g-101 */
_MAPINIT(irem_g101);
_MAPIO(irem_g101);
/* h-3001 */
_MAPINIT(irem_h3001);
_MAPIO(irem_h3001);
_MAPIRQ(irem_h3001);
/* simple */
_MAPINIT(irem_l1);
_MAPIO(irem_l1);
/* simple */
_MAPINIT(irem_l2);
_MAPIO(irem_l2);
/* simple */
_MAPINIT(irem_l3);
_MAPIO(irem_l3);



/* jaleco */
/* ss88006 */
_MAPINIT(jaleco_ss88006);
_MAPIO(jaleco_ss88006);
_MAPIRQ(jaleco_ss88006);
/* simple */
_MAPINIT(jaleco_l1);
_MAPIO(jaleco_l1);
/* simple */
_MAPINIT(jaleco_l2);
_MAPIO(jaleco_l2);
/* simples */
_MAPINIT(jaleco_l3);
_MAPIO(jaleco_l3);
/* simple */
_MAPINIT(jaleco_l4);
_MAPIO(jaleco_l4);
/* simple */
_MAPINIT(jaleco_l5);
_MAPIO(jaleco_l5);



/* konami */
/* vrc */
_MAPINIT(konami);
_MAPIO(konami);
_MAPIRQ(konami_vrc3);
_MAPIRQ(konami_vrc467);



/* misc */
/* caltron */
_MAPINIT(caltron);
_MAPIO(caltron6);
_MAPIO(caltron8);
/* capcom simple */
_MAPINIT(capcom_l1);
_MAPIO(capcom_l1);
/* nichibutsu simple */
_MAPINIT(nichibutsu_l1);
_MAPIO(nichibutsu_l1);



/* namcot */
/* namcot 106 */
_MAPINIT(namcot_106);
_MAPIO(namcot_106);
_MAPIO_R(namcot_106);
_MAPIRQ(namcot_106);
_MAPPPU_W(namcot_106,name0);
_MAPPPU_W(namcot_106,name1);
_MAPPPU_W(namcot_106,name2);
_MAPPPU_W(namcot_106,name3);



/* nintendo */
/* bnrom */
_MAPINIT(bnrom);
_MAPIO(bnrom);
/* nrom */
_MAPINIT(nrom);
_MAPIO(nrom_fb_wram); /* familybasic */
_MAPSWITCHINIT(nrom_fb); /* " */
_MAPSWITCHSAVE(nrom_fb); /* " */
/* uxrom */
_MAPINIT(unrom);
_MAPIO(unrom);
/* cnrom */
_MAPINIT(cnrom);
_MAPIO(cnrom);
_MAPIO(cnrom_bs); /* bandai speech chip */
_MAPIO(cnrom_bus); /* bus conflicts */
_MAPIO(cnrom_dis); /* chr disable... */
_MAPPPU_R(cnrom_dis,pt0a);
_MAPPPU_R(cnrom_dis,pt0b);
_MAPPPU_R(cnrom_dis,pt0c);
_MAPPPU_R(cnrom_dis,pt0d);
_MAPPPU_R(cnrom_dis,pt1a);
_MAPPPU_R(cnrom_dis,pt1b);
_MAPPPU_R(cnrom_dis,pt1c);
_MAPPPU_R(cnrom_dis,pt1d);
/* axrom */
_MAPINIT(aorom);
_MAPIO(aorom);
/* cprom */
_MAPINIT(cprom);
_MAPIO(cprom);
/* gxrom */
_MAPINIT(gnrom);
_MAPIO(gnrom);



/* nintendo mmc */

/* mmc1 */
/* all */
_MAPINIT(mmc1);
_MAPIO(mmc1);
/* nwc */
_MAPSWITCHINIT(mmc1_event);
_MAPSWITCHSAVE(mmc1_event);
_MAPIRQ(mmc1_event);



/* mmc2/4 */
_MAPINIT(mmc2);
_MAPIO(mmc2);
_MAPPPU_R(mmc2,pt0d);
_MAPPPU_R(mmc2,pt1d);



/* mmc3/6, and compatibles */
_MAPINIT(mmc3);
_MAPIO(mmc3);
_MAPA12(mmc3b1);
_MAPA12(mmc3b2);
/* mmc6 */
_MAPIO_R(mmc6_wram_handler);
_MAPIO(mmc6_wram_handler);
/* nes-qj */
_MAPIO(mmc3_qj);
/* marioparty */
_MAPIO(mmc3_marioparty);
/* smb+tetris+wc */
_MAPIO(mmc3_3in1);



/* mmc5 */
_MAPINIT(mmc5);
_MAPIO(mmc5);
_MAPIO_R(mmc5);
_MAPIO(mmc5_pb);
_MAPIRQ(mmc5);
_MAPAPUCLOCK(mmc5);

_MAPPPU_R(mmc5,pt0a);
_MAPPPU_R(mmc5,pt0b);
_MAPPPU_R(mmc5,pt0c);
_MAPPPU_R(mmc5,pt0d);
_MAPPPU_R(mmc5,pt1a);
_MAPPPU_R(mmc5,pt1b);
_MAPPPU_R(mmc5,pt1c);
_MAPPPU_R(mmc5,pt1d);
_MAPPPU_R(mmc5,name0);
_MAPPPU_R(mmc5,name1);
_MAPPPU_R(mmc5,name2);
_MAPPPU_R(mmc5,name3);

_MAPPPU_W(mmc5,name0);
_MAPPPU_W(mmc5,name1);
_MAPPPU_W(mmc5,name2);
_MAPPPU_W(mmc5,name3);



/* pirate */
/* contra function 16 */
_MAPINIT(contraf16);
_MAPIO(contraf16);
/* mariobaby */
_MAPINIT(mariobaby);
_MAPIO(mariobaby_8);
_MAPIO(mariobaby_e);
_MAPIRQ(mariobaby);
/* smb2j fds bootlegs */
_MAPINIT(smb2j);
_MAPIO(smb2j_8);
_MAPIO(smb2j_a);
_MAPIO(smb2j_e);
_MAPIO(smb2j);
_MAPIRQ(smb2j);
/* wai xing zhan shi */
_MAPINIT(waixing);
_MAPIO(waixing);



/* sunsoft */
/* 1 */
_MAPINIT(sunsoft1);
_MAPIO(sunsoft1);
/* 2 */
_MAPINIT(sunsoft2);
_MAPIO(sunsoft2);
/* 3 */
_MAPINIT(sunsoft3);
_MAPIO(sunsoft3);
_MAPIRQ(sunsoft3);
/* 4 */
_MAPINIT(sunsoft4);
_MAPIO(sunsoft4);
_MAPPPU_W(sunsoft4,name0);
_MAPPPU_W(sunsoft4,name1);
_MAPPPU_W(sunsoft4,name2);
_MAPPPU_W(sunsoft4,name3);
/* 5 */
_MAPINIT(sunsoft5);
_MAPIO(sunsoft5_index);
_MAPIO(sunsoft5_data);
_MAPIO(sunsoft5_sound_address);
_MAPIO(sunsoft5_sound_data);
_MAPIRQ(sunsoft5);



/* taito */
/* tc */
_MAPINIT(taito_tc);
_MAPIO(taito_tc_8);
_MAPIO(taito_tc_a);
_MAPIO(taito_tc_c);
_MAPIO(taito_tc_e);
_MAPIRQ(taito_tc);
/* x */
_MAPINIT(taito_x);
_MAPIO(taito_x);



/* tengen */
/* rambo-1 */
_MAPINIT(tengen_rambo1);
_MAPIO(tengen_rambo1);
_MAPA12(tengen_rambo1);
_MAPIRQ(tengen_rambo1);
/* simple */
_MAPINIT(tengen_l1);
_MAPIO(tengen_l1);



/* unlicensed */
/* action 52 */
_MAPINIT(action52);
_MAPIO(action52);
_MAPIO(action52_ram);
_MAPIO_R(action52_ram);
/* camerica bf9093/97 */
_MAPINIT(camerica);
_MAPIO(camerica_ce);
_MAPIO(camerica_bf9097);
/* camerica bf9096 */
_MAPINIT(camerica_bf9096);
_MAPIO(camerica_bf9096_aladdin);
_MAPIO(camerica_bf9096_8a);
_MAPIO(camerica_bf9096_ce);
/* colordreams types */
_MAPINIT(colordreams);
_MAPIO(colordreams);
/* rumblestation */
_MAPINIT(rumblestation);
_MAPIO(rumblestation_hi);
_MAPIO(rumblestation_lo);

#endif /* MAPPER_H */
