#ifndef SETTINGS_H
#define SETTINGS_H

/* enums */
enum {
	/* draw.c */
	SETTINGS_VSYNC=0,
	SETTINGS_RENDERTYPE,
	SETTINGS_FLIPX,
	SETTINGS_BFILTER,
	SETTINGS_SOFTRENDER,
	SETTINGS_ILLEGAL,	/* (cpu.c) */
	SETTINGS_MESSAGES,
	SETTINGS_FORCE5060,
	SETTINGS_CLIPUP,	SETTINGS_CLIPDOWN,	SETTINGS_CLIPLEFT,	SETTINGS_CLIPRIGHT,
	SETTINGS_ASPECTRATIO,
	SETTINGS_MERGEFIELDS,
	SETTINGS_STRETCH,
	SETTINGS_WINDOWZOOM,
	SETTINGS_FULLSCREEN,
	SETTINGS_VIDFORMAT,
	SETTINGS_VIDSIGNAL,
	SETTINGS_PALETTE,
	SETTINGS_DECODER,
	SETTINGS_RYANGLE,	SETTINGS_GYANGLE,	SETTINGS_BYANGLE,
	SETTINGS_RYGAIN,	SETTINGS_GYGAIN,	SETTINGS_BYGAIN,
	SETTINGS_HUE,
	SETTINGS_SATURATION,
	SETTINGS_CONTRAST,
	SETTINGS_BRIGHTNESS,
	SETTINGS_SHARPNESS,
	SETTINGS_GAMMA,
	SETTINGS_RESOLUTION,
	SETTINGS_ARTIFACTS,
	SETTINGS_FRINGING,
	SETTINGS_BLEED,
	SETTINGS_SAVEPALETTE,
	SETTINGS_FRAMESKIP,
	SETTINGS_BC,
	SETTINGS_BG,
	
	/* sound.c */
	SETTINGS_SOUND,
	SETTINGS_SLEEP,
	SETTINGS_BUFSIZE,
	SETTINGS_PRIORITY,	/* nes.c */
	SETTINGS_CPUSPEED,	/* crystal.c */
	
	/* input.c */
	SETTINGS_UPDFREQUENCY,
	SETTINGS_INPBG,
	SETTINGS_JOYSTICK,
	SETTINGS_PORT1,
	SETTINGS_PORT2,
	SETTINGS_PORTEXT,
	
	/* mapper.c */
	SETTINGS_FBSWITCH,
	SETTINGS_NWCDIPS,
	
	/* file.c */
	SETTINGS_FILTERINDEX,	/* nes.c */
	SETTINGS_ROMDIR,
	SETTINGS_PALETTEDIR,
	SETTINGS_PATCHDIR,
	SETTINGS_SAMPLEDIR,
	SETTINGS_SRAMDIR,
	SETTINGS_STATEDIR,
	
	SETTINGS_MAX
};

enum {
	SETTINGS_TYPE_STRING=0,
	SETTINGS_TYPE_INT,
	SETTINGS_TYPE_FLOAT,
	
	SETTINGS_TYPE_MAX
};

void settings_init(void);
void settings_clean(void);
void settings_save(void);

void settings_disable_warning(void);
int settings_notfound(void);
int settings_get_runtimes(void);

int settings_get(const char*,char**,int*,float*);
#define SETTINGS_GET_STRING(x,y)	settings_get(x,y,NULL,NULL)
#define SETTINGS_GET_INT(x,y)		settings_get(x,NULL,y,NULL)
#define SETTINGS_GET_FLOAT(x,y)		settings_get(x,NULL,NULL,y)
int settings_get_yesnoauto(int);

int settings_put(const int,const char*,const char*,const int,const float);
#define SETTINGS_PUT_STRING(x,y)	settings_put(SETTINGS_TYPE_STRING,x,y,0,0.0)
#define SETTINGS_PUT_INT(x,y)		settings_put(SETTINGS_TYPE_INT,x,NULL,y,0.0)
#define SETTINGS_PUT_FLOAT(x,y)		settings_put(SETTINGS_TYPE_FLOAT,x,NULL,0,y)
void settings_put_yesnoauto(int,int);

const char* settings_info(u32);

#endif /* SETTINGS_H */
