#ifndef YM2413_H
#define YM2413_H

/*
Slightly modified version of Jarek Burczynski's YM2413 emulator, to work nicely
in this environment. If you wish to use this emulator (that is, the source),
consult MAME: http://www.mamedev.com/

Also uses VRC7 instrument table by Kevin Horton.
*/

void *YM2413Init(int clock, int rate);
void YM2413Shutdown(void *chip);
void YM2413ResetChip(void *chip);
void YM2413Write(void *chip, int a, int v);
unsigned char YM2413Read(void *chip, int a);
void YM2413UpdateOne(void *chip, signed short **buffers, int length);

typedef void (*OPLL_UPDATEHANDLER)(void *param,int min_interval_us);
void YM2413SetUpdateHandler(void *chip, OPLL_UPDATEHANDLER UpdateHandler, void *param);


/**********/

void ym2413_init(void);
void ym2413_reset(void);
void ym2413_clean(void);
void __fastcall ym2413_write_address(u8);
void __fastcall ym2413_write_data(u8);
void __fastcall ym2413_update(signed short*,int);

#endif /* YM2413_H */
